package martinpearman.co.uk.b4a.jsinterface;

import android.webkit.WebView;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BA.Author;

@ShortName("JSInterface")
@Version(2)
@Author("Martin Pearman")

public class JSInterface
 {
	BA ba;
	public void Initialize(BA ba, WebView myWebView, String interfaceName)
	{
		this.ba = ba;
		myWebView.addJavascriptInterface(this, interfaceName);
	}	
	
	// hard coded methods
	public Integer getInt()
	{
		return 1;
	}
	
	public String newMethod()
  {
		return "This is newMethod()";
	}
	
	public String strReverse(String source)
  {
		int i, len = source.length();
		StringBuffer dest = new StringBuffer(len);

		for (i = (len - 1); i >= 0; i--)
			dest.append(source.charAt(i));
		return dest.toString();
	}

	// call B4A Subs that must accept and return Strings
	public String CallSub0(String sub)
	{
		sub = sub.toLowerCase();
		return ba.raiseEvent(this, sub, new Object[0]);
	}

	public String CallSub1(String sub, String param1)
	{
		sub = sub.toLowerCase();
		return ba.raiseEvent(this, sub, new Object[] = { param1 });
	}	
	
	public String CallSub2(String sub, String param1, String param2)
	{
		sub = sub.toLowerCase();
		return ba.raiseEvent(this, sub, new Object[] = { param1, param2 });
	}	
	
}
